#include "SPI.h"
#include "Adafruit_GFX.h"
#include "Adafruit_ILI9341.h"

////////// C O N E X I O N E S ///////////
#define TFT_DC 9
#define TFT_CS 10
// SCK          PIN13
// SDO(MISO)    PIN12
// SDI (MOSI)   PIN11
// 3.3V  --> Vcc / LED / RESET

  Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC);
  
  int x=50;
  int y=50;
  int xVida=0;
  int yVida= 400;
  int Sx=1;
  int Sy=1;
  int Ax=6;
  int Ay=6;
  int pot = 100;
  int score = 0;
  int score_anterior = 0;
  int velocidad = 1;
  extern const unsigned char  corazon[];

  void setup() {
    Serial.begin(9600);
    tft.begin();
    tft.fillScreen(ILI9341_BLACK);
    tft.setTextColor(ILI9341_WHITE);
    tft.setTextSize(4);
    tft.setCursor(20, 100);
    tft.print("INVADERS");
    delay(2000);
    tft.fillScreen(ILI9341_BLACK);

  }

  void loop() {
    tft.setCursor(10, 10);
    tft.drawBitmap(xVida, yVida, corazon,30 ,30, ILI9341_BLACK);
    tft.setTextColor(ILI9341_WHITE, ILI9341_BLACK);
    tft.fillCircle(x,y,10,ILI9341_BLACK);
    tft.fillRect(pot,280,30,10, ILI9341_BLACK);
 
    if(x>230 || x<10) Sx = -Sx;
    if(y>270 && x>pot+10 && x<pot+20 && y<272+Ay) {Sy=-Sy; Ax=Ax+1; Ay=Ay+1; score++; velocidad++;}
    if(y>270 && x>pot+3 && x<pot+10 && y<272+Ay) {Sy=-Sy; Ax=Ax+1; Ay=Ay+2; score++;velocidad++;}
    if(y>270 && x>pot+20 && x<pot+27 && y<272+Ay) {Sy=-Sy; Ax=Ax+2; Ay=Ay+1; score++;velocidad++;}
    if(y>270 && x>pot && x<=pot+3 && y<272+Ay) {Sy=-Sy; Ax=Ax+1; Ay=Ay+3; score++;velocidad++;}
    if(y>270 && x>=pot+27 && x<pot+36 && y<272+Ay) {Sy=-Sy; Ax=Ax+3; Ay=Ay+1; score++;velocidad++;}
    if(y<10) Sy = -Sy;
    if(xVida>pot && xVida<pot+30 && yVida>270 && yVida<274) {--Ax; --Ay; velocidad--;}
    if(score != score_anterior && score % 2 == 0) {xVida=analogRead(A0)%5*11; yVida= -10; score_anterior = score; yVida= 400;} 
    x=x+Sx*Ax;
    y=y+Sy*Ay;
    yVida = yVida +6;
    pot = analogRead(A0)/5;
    tft.fillCircle(x,y,10,0x67E0);
    tft.fillRect(pot,280,30,10, 0xFC7F);
    tft.setTextSize(3);
    tft.println(score);
    tft.setTextSize(1);
    tft.println("SCORE");
    tft.setTextSize(2);
    tft.print(" ");
    tft.setTextSize(3);
    tft.println(velocidad);
    tft.setTextSize(1);
    tft.println("SPEED");
    tft.setTextSize(3);
    tft.drawBitmap(xVida, yVida, corazon,30 ,30, ILI9341_RED);
    delay(33);  
  }
